import os.path,subprocess,sys
from subprocess import STDOUT,PIPE
import time
from threading  import Thread
from queue import Queue, Empty
class Process_Terminal:
    def __init__(self):
        self.__proc=None
        self.__read_thread=None
        self.__queue_data=Queue()
        self.__ON_POSIX='posix' in sys.builtin_module_names
        self.__character_code=str()
        if self.__ON_POSIX:
            self.__character_code="utf-8"
        else:
            self.__character_code='sjis'
    def process_run_state(self):
        if self.__proc==None:
            return False
        if self.__proc.poll() is  None:
            return True
        else:
            False
        
    def __enqueue_output(self,out, queue):
        for line in iter(out.readline, b''):
            queue.put(line)
        out.close()
    def execute_process(self,execute_command,working_directory="./"):
        
        if not(self.process_run_state()):
            cmd=[]
            if self.__ON_POSIX:
                cmd=str(execute_command+" && sleep 5").split(" ")
            else:
                cmd=str(execute_command+" & ping localhost -n 5 >nul").split(" ")
            checkd_cmd=[]
            for check in cmd:
                if check=="":
                    pass
                else:
                    checkd_cmd.append(check)
            cmd=checkd_cmd
            self.__proc = subprocess.Popen(cmd,shell=True, cwd=working_directory,stdin=PIPE, stdout=PIPE, stderr=STDOUT,bufsize=1, close_fds=self.__ON_POSIX)
            self.__read_thread = Thread(target=self.__enqueue_output, args=(self.__proc.stdout, self.__queue_data))
            self.__read_thread.daemon = True
            self.__read_thread.start()
            while not(self.process_run_state()):
                time.sleep(0.1)
            return None
    def input_std(self,stdin):
        if self.process_run_state():
            self.__proc.stdin.write(stdin.encode( self.__character_code))
            self.__proc.stdin.flush()
            return True
        else:
            return 
    def read_std(self):
        stdout=[]
        while True:
            line=None
            try:  
                line = self.__queue_data.get_nowait()
            except Empty:
                break
            stdout.append(line.rstrip().decode(self.__character_code))
        return stdout


"""
a=Process_Terminal()
command="java -Xms1024M -Xmx1024M -jar server.jar nogui"
#command="NaganoProconClient.exe"
a.execute_process(command)
count=0
while True:
    if input("1or2")=="1":
        print(a.input_std("stop\n"))
    else:
        print(a.read_std())
    if not(a.process_run_state()):
        print(a.read_std())
        break
exit()
"""